#encoding: utf-8
#----------------------------------------
# Mod pour \pokemonsdk\scripts\01400 GamePlay\00300 Bag\00300 Bag.rb
#----------------------------------------
# Permet de bloquer l'acces au sac grâce à l'option "NoItemOnBattle" de Death Overhaul.
# Nécessite son script frère "16101 Objets interdits.rb" pour fonctionner. Si utilisé indépendament de Death Overhaul, renseigner en ligne 15 le numéro de la variable "NoItemOnBattle".
# Dans Sacred Phoenix, ce mod est déjà mergé à l'un qui modifie déjà le sac. (Donc ne pas l'installer chez moi.)

# ---------- Partie à paramétrer par le maker si ce plug-in est utilisé de manière standalone ----------
# (Ce code sera ignoré si DEATH_OVERHAUL est détecté)

module Yuki
	module Var
		unless defined?(DEATH_OVERHAUL)
		NoItemOnBattle = 174 # Permet de restreindre l'utilisation des objets en combat. 0 = Pas de restriction (vanilla), 1 et + : divers niveaux de restrictions avec un message différents (cf PDF d'installation).
		end
	end
end

# ---------- Fin de la partie à paramétrer par le maker si ce plug-in est utilisé de manière standalone ----------

module GamePlay
	# Scene responsive of displaying the bag
	#
	# The bag has various modes :
	#	 - :menu : when opened from the menu
	#	 - :battle : when opened from the battle
	#	 - :berry : when opened to plant berry
	#	 - :hold : when opened to give an item to a Pokemon
	#	 - :shop : when opened to sell item
	#	 - :map : when an event request an item
	class Bag < BaseCleanUpdate
		remove_const :POCKETS_PER_MODE
		# List of pocket index the player can see according to the modes
		POCKETS_PER_MODE = {
			menu: [1, 2, 6, 3, 5, 4, 8],
			battle: [2, 6, 4],
			berry: [4],
			hold: [1, 2, 6, 4],
			shop: [1, 2, 6, 3, 4],
			ball: [2]
		}
		
		# Load the pockets index & names
		def load_pockets
			if @mode == :battle and $game_variables[Yuki::Var::NoItemOnBattle] >= 2
				@pocket_indexes = POCKETS_PER_MODE[:ball] # On laissera l'accès au sac en restreignant uniquement aux Pokéballs si le joueur s'est interdit les objets sur tous les combats.
			else
				@pocket_indexes = POCKETS_PER_MODE[@mode]
			end
			@pocket_names = @pocket_indexes.collect { |id| get_text(POCKET_NAMES[id]) }
		end

	end
end


