#encoding: utf-8
#----------------------------------------
# Mod pour \pokemonsdk\scripts\01200 PFM\01800 PFM__Pokemon.rb
#----------------------------------------
# Version lite gérant que le boost de ball, le Grelot Zen, l'influence de la nature et les pertes KO.
# Inclut le fix PSDK 24.58 qui avait renommé l'argument de la "def loyalty"

LOYALTY_OVERHAUL = true # Ne pas toucher, permet au moteur de jeu de détecter la présence du mod. (Très utile pour une compatibilité automatique de mes autres mods.)

module PFM
	class Pokemon
		BALL_B = [11,497,936,937,938] #Les ID des balls donnant un boost de *2 sur l'hausse de bonheur. La Copain ball est traitée comme Luxe Ball à défaut d'être codée sur PSDK.
		FRIENDY_ITEM = [218] # Grelot Coque
		MAX_H = 255 #Bonheur maximal autorisé
		#Variations dûes à la nature [↑ Bonheur, ↓ Bonheur, ↑ dread, ↓ dread, Equilibre de base de la crainte] - les 3 dernières valeurs ne sont pas utilisées dans la version lite.
		NATURE_INFLUENCE = [
		[1.1,1.0,0.8,1.2,425], #0-Hardi
		[0.8,1.0,1.0,1.0,425], #1-Solo
		[1.1,1.0,0.8,1.2,425], #2-Brave
		[0.9,1.1,0.9,1.1,400], #3-Rigide
		[0.8,1.2,0.8,1.2,400], #4-Mauvais
		[0.9,0.9,0.8,1.2,400], #5-Assuré
		[1.2,0.9,1.2,0.8,500], #6-Docile
		[1.0,0.9,0.8,1.0,425], #7-Relax
		[1.0,1.0,0.8,1.0,425], #8-Malin
		[1.0,1.2,1.2,0.8,475], #9-Lâche
		[0.8,1.0,1.2,0.8,475], #10-Timide
		[1.2,1.1,1.1,1.0,475], #11-Pressé
		[1.0,1.0,1.0,1.0,450], #12-Sérieux
		[1.2,0.9,0.9,1.0,475], #13-Jovial
		[1.2,1.2,1.2,1.2,450], #14-Naïf
		[0.9,0.9,1.2,1.0,475], #15-Modeste
		[1.2,0.8,1.1,1.0,500], #16-Doux
		[0.8,1.0,1.2,0.8,500], #17-Discret
		[0.8,0.8,0.8,0.8,450], #18-Pudique
		[1.2,1.2,1.1,1.1,450], #19-Foufou
		[1.0,0.8,0.8,1.1,450], #20-Calme
		[1.2,0.8,1.2,0.8,500], #21-Gentil
		[0.8,1.2,0.9,1.0,400], #22-Malpoli
		[0.8,1.0,1.2,1.0,450], #23-Prudent
		[1.1,1.1,1.0,0.9,450]] #24-Bizarre

		def loyalty=(loyalty)
			#puts "@loyalty : #{@loyalty}"#Amitié de base retourne nil si no modif
			#puts "loyalty : #{loyalty}"#Amitié de base si @loyalty nil, sinon amitié de base + modif SANS bonus
			unless @loyalty == nil
				loyalty = (@loyalty+(loyalty-@loyalty)*get_loyalty(@loyalty-loyalty)).round
			end
			#puts "loyalty modifiée : #{loyalty}"
			@loyalty = loyalty.clamp(0, MAX_H)
		end

		#Pour récupérer les différentes variations de bonheur (ball, nature)
		def get_loyalty(d)
			#puts "Différence : #{d}"
			boost = 1
			if BALL_B.any?(@captured_with) and d < 0
				boost *= 2
			end
			if FRIENDY_ITEM.any?(@item_holding) and d < 0
				boost *= 1.5
			end

			boost *= NATURE_INFLUENCE[nature_id][0] if d < 0 #Hausse de bonheur
			boost *= NATURE_INFLUENCE[nature_id][1] if d > 0 #Baisse de bonheur

			return boost
		end

	end
end