﻿#encoding: utf-8
#----------------------------------------
# Mod pour \pokemonsdk\scripts\01600 Scene_Battle\00300 Scene_Battle_Event_Functions.rb
#----------------------------------------
# Partie gérant la difficulté des dresseurs via une modification de leur niveau. Lié à Death Overhaul, ce plug-in peut néanmoins être utilisé de manière indépendante en renseignant la ligne 10.

module Yuki
	module Var
		unless defined?(DEATH_OVERHAUL)
			Difficulty = 122
			# Inutile de renseigner cette ligne si le mod DEATH_OVERHAUL est installé, ces réglages sont tous regroupés dans "00500 Death overhaul - master - Gestion cycle vie-mort". Si à l'inverse, ce plug-in est utilisé de manière standalone, renseignez la variable RMXP que vous utiliser pour votre difficulté.
		end
	end
end

class Scene_Battle
  alias old_init_trainer_battle init_trainer_battle
  def init_trainer_battle(actor_cnt = 1)
    id = $game_variables[::Yuki::Var::Trainer_Battle_ID]
    id = 0 if(id >= GameData::Trainer.all.size or id < 0)
	$trainerclone = GameData::Trainer.all[id].team.clone # Non utilisé in-game, mais permet de taper sur la console "$trainerclone" pour avoir les données du dresseur dessus.
    old_trainer_team = Marshal.load(Marshal.dump(GameData::Trainer.all[id].team))
    team = GameData::Trainer.all[id].team
    # Calibrate the team
    case $game_variables[Yuki::Var::Difficulty]
    when -1 # EASY
      team.each { |pokemon| pokemon[:level] = [(pokemon[:level] * 0.9).floor,1].max if pokemon.is_a?(Hash) }
    when 1 # HARD
      team.each { |pokemon| pokemon[:level] = [(pokemon[:level] * 1.1).ceil,PSDK_CONFIG.pokemon_max_level].min if pokemon.is_a?(Hash) }
    end
    old_init_trainer_battle(actor_cnt)
    # Reset the team to its original state
    GameData::Trainer.all[id].team = old_trainer_team
  end
end