#encoding: utf-8
#----------------------------------------
# Mod pour \pokemonsdk\scripts\01400 GamePlay\00200 Scene_Map.rb
# Mod pour \pokemonsdk\scripts\01200 PFM\00010 Pokemon_Party\00200 Accessors.rb
#----------------------------------------
# Ajout de l'option "Poison à l'ancienne" pour Death Overhaul
# Attention, le black out n'est pas géré si jamais toute l'équipe était KO ou morte in map. (Impossible de l'intégrer sur PSDK Vanilla sans bug.)


class Scene_Map
	# Display the end of poisoning sequence
	# @param pokemon [PFM::Pokemon] previously poisoned pokemon
	def display_poison_fainted(pokemon)
		PFM::Text.set_pknick(pokemon, 0)
		display_message(parse_text(100, 81))
	end
	def display_poison_dying(pokemon)
		PFM::Text.set_pknick(pokemon, 0)
		display_message(parse_text(100, 82))
	end
	def display_poison_allfainted
		display_message(parse_text(100, 95))
	end
end


module PFM
	class Pokemon_Party
	
		# The nuzlocke logic - Code mis en double ici pour assurer la compatiblité de Death Overhaul sur les anciennes versions de PSDK (24.51 et antérieures).
		# @return [Nuzlocke]
		attr_accessor :nuzlocke
		on_player_initialize(:nuzlocke) { @nuzlocke = Nuzlocke.new }
		on_expand_global_variables(:nuzlocke) do
			# Variable containing the Nuzlocke Logic
			@nuzlocke ||= Nuzlocke.new
		end
	
		# Update the processing of the poison event
		def poison_update
			return unless (@steps - (@steps / 8) * 8) == 0
			return if cant_process_event_tasks?

			psn_event = false
			@actors.each do |pokemon|
				next unless pokemon.poisoned? || pokemon.toxic?

				$scene.delay_display_call(:display_poison_animation) unless psn_event
				psn_event = true
				pokemon.hp -= (pokemon.toxic? ? 2 : 1)
				next unless pokemon.hp <= 0
				if $game_switches[Yuki::Sw::OldSchoolPoison] == true # Poison à l'ancienne
					pokemon.hp = 0
					if $game_variables[Yuki::Var::Mortality] == 2 # Mortalité en mode Nuzlocke
						if REINCARNATION == true and !(pokemon.type_spectre? and not pokemon.id == 487)
							pokemon.status = GameData::States::Mort
							pokemon.death_c =$game_variables[Yuki::Var::TimeElapsed]+SOUL_COOLDOWN
						else
							pokemon.status = GameData::States::Mort_d
						end
						pokemon.loyalty -= 60
						$scene.delay_display_call(:display_poison_dying, pokemon)
					else
						pokemon.status = 9
						pokemon.loyalty -= 5
						$scene.delay_display_call(:display_poison_fainted, pokemon)	
					end
				else # Poison 4G
					pokemon.hp = 1
					pokemon.cure
					pokemon.loyalty -= 3
					$scene.delay_display_call(:display_poison_end, pokemon)
				end	
			end
		end

	end
end