#encoding: utf-8
#----------------------------------------
# Mod pour \pokemonsdk\scripts\01200 PFM\00800 PFM__Pokemon_Party_(Gestion).rb
#----------------------------------------
# Interdit le heal des Pokémons morts et ne permet qu'un soin partiel du KO au bord de la mort.
# Créé 2 méthodes alternatives de soin (une plus forte et une partielle)

module PFM
	class Pokemon_Party	

		def full_heal_party
			@actors.each do |pokemon|
				next unless pokemon
					next if pokemon.status == GameData::States::Mort or pokemon.status == GameData::States::Mort_d #Si Pokémon mort on ne le soigne pas
					pokemon.cure
					pokemon.hp = pokemon.max_hp
					pokemon.skills_set.each do |skill|
						skill&.pp = skill.ppmax
				end
			end
		end

		def heal_party
			@actors.each do |pokemon|
				next unless pokemon
					next if pokemon.status == GameData::States::Mort or pokemon.status == GameData::States::Mort_d #Si Pokémon mort on ne le soigne pas
					if pokemon.status == GameData::States::Damaged #K.O. au bord de la mort
						pokemon.status = 9
						pokemon.hp = 0
					else
						pokemon.cure
						pokemon.hp = pokemon.max_hp
					end
					pokemon.skills_set.each do |skill|
						skill&.pp = skill.ppmax
				end
			end
		end

		def partial_heal_party
			@actors.each do |pokemon|
				next unless pokemon
					next if pokemon.status == GameData::States::Mort or pokemon.status == GameData::States::Mort_d or pokemon.status == GameData::States::KO or pokemon.status == GameData::States::Damaged#LE KO n'est pas soigné ici
					pokemon.cure
					pokemon.hp = pokemon.hp + (pokemon.max_hp/2) 
					pokemon.hp = pokemon.max_hp if pokemon.hp > pokemon.max_hp
					pokemon.skills_set.each do |skill|
					skill&.pp = skill&.pp + (skill.ppmax/3)
					skill&.pp = skill.ppmax if skill&.pp > skill.ppmax
				end
			end
		end

		def alive?
			alive_pokemon = @actors.find { |pokemon| pokemon && !pokemon.dead? && !pokemon.mort? && !pokemon.mort_d? }
			return !alive_pokemon.nil?
		end
	end
end
