#encoding: utf-8
# ------------------------------
# Mod pour \pokemonsdk\scripts\01200 PFM\00100 Global Systems\01600 Nuzlocke.rb
# ------------------------------

module PFM
	# Class responsive of managing Nuzlocke information and helping to implement the nuzlocke logic
	# @author Logically anime and ralandel
	
	# Storage of dead Pokemon to re-use later in other systems
	# @return [Array<PFM::Pokemon>]
	attr_accessor :graveyard # Pour garder la compatibilité en cas de retrait du mod.

	class Nuzlocke
		# Create a new Nuzlocke object
		def initialize # Def laissée pour la compatibilité avec les anciennes versions de PSDK.
			@catch_locked_zones = []
			@no_lock_on_duplicate = false # Ignorer cette ligne pour le Death Overhaul, c'est le $game_switches[Yuki::Sw::DupesClause] qui fait foi.
			@graveyard = [] # Pour garder la compatibilité en cas de retrait du mod.
		end

		# On efface le contenu de cette def pour éviter des conflits de mods puisque Death Overhaul ne gère pas du tout comme ça.
		def clear_dead_pokemon
		end
		alias dead clear_dead_pokemon

		# Lock the current zone (prevent Pokemon from being able to be caught here)
		def lock_catch_in_current_zone
			return if catching_locked_here? || $game_temp.trainer_battle
			@catch_locked_zones.push($env.master_zone)
		end

		# Tell if catching is locked in the given zone
		# @param id [Integer] ID of the zone
		# @return [Boolean]
		def catching_locked?(id)
			@catch_locked_zones.include?(id)
		end

		# Tell if catching is locked in the current zone
		# @return [Boolean]
		def catching_locked_here?
			catching_locked?($env.master_zone)
		end
	end
end
