#encoding: utf-8
#----------------------------------------
# Mod pour \pokemonsdk\scripts\01600 Scene_Battle\00600 Scene_Battle_Graphics.rb
#----------------------------------------
# Merge de 4 mods
# Principalement pour la gestion de la mort des Pokémons.
# + Petite modif sur la ligne 32 (méthode BattleEngine._message_check pour intégrer les 2 nouveaux textes d'efficacité possibles pour le mod des textes d'efficacité - ligne sans conséquence si le mod "Overhaul texte efficacité" n'est pas installé. La laisser assure la compatibilité.
# + Gestion du coefficient d'enthousiame du public (4 appels "@sp_money") pour les gains d'argent en cas de mise hors-combat si le mod MONEY_KELTIOS est installé. (Détecté automatiquement)
# + Gestion de la parte d'amitié suite au KO (1 appel "loyalty_loss(pokemon)") pour les gains d'argent en cas de mise hors-combat si le mod LOYALTY_OVERHAUL est installé. (Détecté automatiquement)

class Scene_Battle
	include UI

	def mort(pokemon)	
		@sp_money += 15 if defined?(MONEY_KELTIOS) #Enthousiasme +15 pour mort
		if pokemon.type_spectre? and not pokemon.id == 487
			display_message(parse_text_with_pokemon(100, 20, pokemon, 
			BattleEngine::PKNICK[0] => pokemon.given_name))
		else
			display_message(parse_text_with_pokemon(100, 14, pokemon, 
			BattleEngine::PKNICK[0] => pokemon.given_name))
			pokemon.death_c =$game_variables[Yuki::Var::TimeElapsed]+SOUL_COOLDOWN if pokemon.position >= 0 && REINCARNATION == true #Si le Pokémon mort est un allié, on le met en liste d'attente des morts. On skip si la réincarnation est désactivée.
		end
	end


	#===
	#>Animation du KO
	#===
	def phase4_animation_KO(pokemon)
		$quests.beat_pokemon(pokemon.id) if pokemon.position < 0
		while(message = BattleEngine._message_check(:critical_hit, :extrem_unefficient_msg, :efficient_msg, :unefficient_msg, :extrem_efficient_msg, :parametre))	# <= Ajouts sur cette ligne
			BattleEngine::BE_Interpreter.send(*message)
		end
		if pokemon.position < 0 and $game_switches[Yuki::Sw::EnemyDeath] == false #Si mort desactivé sur un ennemi
			display_message(parse_text_with_pokemon(19, 0, pokemon, 
			BattleEngine::PKNICK[0] => pokemon.given_name))
			@sp_money += 5 if defined?(MONEY_KELTIOS) #Enthousiasme +5 pour K.O.
			unable_to_battle = 1
		elsif pokemon.hp <= -1*pokemon.max_hp and ($game_variables[Yuki::Var::Mortality] == 1 or pokemon.position<0) #Mort d'un Pokémon
			mort(pokemon)
			unable_to_battle = 3
			unable_to_battle = 4 if pokemon.type_spectre? and not pokemon.id == 487
		elsif pokemon.hp <= -0.75*pokemon.max_hp and ($game_variables[Yuki::Var::Mortality] == 1 or pokemon.position<0) #K.O. au bord de la mort d'un Pokémon
			display_message(parse_text_with_pokemon(100, 17, pokemon, 
			BattleEngine::PKNICK[0] => pokemon.given_name))
			unable_to_battle = 2
			@sp_money += 9 if defined?(MONEY_KELTIOS) #Enthousiasme +9 pour K.O. au bord de la mort
		elsif $game_variables[Yuki::Var::Mortality] == 2 and pokemon.position >= 0 #En mode nuzlocke, KO = mort
			mort(pokemon)
			unable_to_battle = 3
			unable_to_battle = 4 if pokemon.type_spectre? and not pokemon.id == 487
		else #Simple K.O.
			display_message(parse_text_with_pokemon(19, 0, pokemon, 
			BattleEngine::PKNICK[0] => pokemon.given_name))
			@sp_money += 5 if defined?(MONEY_KELTIOS) #Enthousiasme +5 pour K.O.
			unable_to_battle = 1
		end
		@message_window.visible = false
		case unable_to_battle
		when 1
			Audio.se_play(pokemon.cry,100,80)
		when 2
			Audio.se_play(pokemon.cry,100,70)
		when 3
			Audio.se_play(pokemon.cry,100,50)
		when 4
			Audio.se_play(pokemon.cry,100,50)
		end
		Graphics.wait(20) #A paramétrer pour avoir les 0.3 secondes
		sp = gr_get_pokemon_sprite(pokemon)
		bar = gr_get_pokemon_bar(pokemon)
		bar.go_out(30)
		bar.refresh
		while bar.moving
			bar.update
			sp.y += 4
			sp.opacity -= 13
			update_animated_sprites
			Graphics.update
		end
		sp.visible = false
		Graphics.wait(30) #A paramétrer pour avoir les 0.5 secondes
		Audio.se_play("Audio/SE/Down.wav", 100, 80)
		case unable_to_battle
		when 1
			pokemon.status = 9
		when 2
			pokemon.status = GameData::States::Damaged
		when 3
			if REINCARNATION == true
				pokemon.status = GameData::States::Mort
			else
				pokemon.status = GameData::States::Mort_d # Permadeath directe si la réincarnation est désactivée.
			end		
		when 4
			pokemon.status = GameData::States::Mort_d
		end
		if defined?(LOYALTY_OVERHAUL)
			loyalty_loss(pokemon) #Perte de bonheur du Pokémon vaincu
		end
		@_EXP_GIVE.push(pokemon)
		BattleEngine::_State_sub_update
	end
	
	def gr_initialize_main_sprites #Patch d'affichage erroné des barres de PV en cas de combat duo lorsque le joueur n'arrive qu'avec un seul Poké apte au combat et tout le reste hors-combat.
		return if @actor_sprites.size > 0
		sprite = nil
		$game_temp.vs_type.times do |i|
			pk = @actors[i]
			pk.position = i if pk and !pk.dead?
            if pk
                @actor_sprites << ::GamePlay::BattleSprite.new(@viewport, pk)
                sprite = @actor_sprites.last
                sprite.zoom_x = sprite.zoom_y = 0
                @actor_bars << ::GamePlay::BattleBar.new(@viewport, pk) unless pk.dead?
                @actor_bars.last.go_out(1).update
            end
			pk = @enemies[i]
			if pk
				pk.position = -i - 1 
				@enemy_fought << pk
			end
			@enemy_sprites << ::GamePlay::BattleSprite.new(@viewport, pk)
			sprite = @enemy_sprites.last
			sprite.zoom_x = sprite.zoom_y = 0 if $game_temp.trainer_battle
			@enemy_bars << ::GamePlay::BattleBar.new(@viewport, pk)
			@enemy_bars.last.go_out(1).update if $game_temp.trainer_battle
		end
		@actors_ground = ::GamePlay::BattleGrounds.new(@viewport, true)
		@enemies_ground = ::GamePlay::BattleGrounds.new(@viewport, false)
		@a_remaining_pk = GamePlay::BattleBalls.new(@viewport, @actors, false)
		@a_remaining_pk.y = 176
		@a_remaining_pk.z = 50
		@viewport.sort_z
		Graphics.transition
		gr_enemy_launch_sequence
		gr_actor_launch_sequence if $game_variables[Yuki::Var::TrainerTransitionType] == 1
		30.times { update_animated_sprites ; Graphics.update }
		gr_actor_launch_sequence unless $game_variables[Yuki::Var::TrainerTransitionType] == 1
	end
end